/****************************************************************************
**
** $Id: profile.h,v 1.13 2004/05/01 07:54:26 riemer Exp $
**
** Copyright (C) 2001-2004 Tilo Riemer <riemer@lincvs.org>,
**                         Frank Hemer <frank@hemer.org>,
**                         Jose Hernandez <joseh@tesco.net>
**
**
**----------------------------------------------------------------------------
**
**----------------------------------------------------------------------------
**
** LinCVS is available under two different licenses:
**
** If LinCVS is linked against the GPLed version of Qt 
** LinCVS is released under the terms of GPL also.
**
** If LinCVS is linked against a nonGPLed version of Qt 
** LinCVS is released under the terms of the 
** LinCVS License for non-Unix platforms (LLNU)
**
**
** LinCVS License for non-Unix platforms (LLNU):
**
** Redistribution and use in binary form, without modification, 
** are permitted provided that the following conditions are met:
**
** 1. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 2. It is not permitted to distribute the binary package under a name
**    different than LinCVS.
** 3. The name of the authors may not be used to endorse or promote
**    products derived from this software without specific prior written
**    permission.
** 4. The source code is the creative property of the authors.
**    Extensions and development under the terms of the Gnu Public License
**    are limited to the Unix platform. Any distribution or compilation of 
**    the source code against libraries licensed other than gpl requires 
**    the written permission of the authors.
**
**
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR 
** IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
** ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY 
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
** GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
** WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
** NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
**
**
** LinCVS License for Unix platforms:
**
** This program is free software; you can redistribute it and/or modify 
** it under the terms of the GNU General Public License as published by 
** the Free Software Foundation; either version 2 of the License, or 
** (at your  option) any later version.  This program is distributed in 
** the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
** even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
** PARTICULAR PURPOSE.
**
** See the GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
*****************************************************************************/


#ifndef PROFILE_H_20010626		// prevent multiple includes
#define PROFILE_H_20010626

//----------------------------------------------------------------------------

#include "config.h"

//----------------------------------------------------------------------------

#include <qstring.h>

//----------------------------------------------------------------------------

class CLincvsProfile
{
public:

   CLincvsProfile() {;}
   
   CLincvsProfile(const QString& name, const int method,
                  const QString& user, const QString& server,
                  const QString& repository, const int sshClientPreset)
      : m_name(name), m_method(method), m_user(user),
        m_server(server), m_repository(repository),
        m_sshClientPreset(sshClientPreset)
      {} 
        
   void name(const QString &n) { m_name = n; }
   void user(const QString &u) { m_user = u; }
   void server(const QString &s) { m_server = s; }
   void repository(const QString &r) { m_repository = r; }
   void method(const int m) { m_method = m; }
   void sshClientPreset(const int p) { m_sshClientPreset = p; }
   
   const QString name()        const { return m_name;            }
   const int     method()      const { return m_method;          }
   const QString user()        const { return m_user;            }
   const QString server()      const { return m_server;          }
   const QString repository()  const { return m_repository;      }
   const int sshClientPreset() const { return m_sshClientPreset; }

private:
   QString m_name;
   int     m_method;
   QString m_user;
   QString m_server;
   QString m_repository;
   int m_sshClientPreset;
};


#endif	   //PROFILE_H_20010626

/*--------- END OF FILE -----------------------------------------------------*/
